//+------------------------------------------------------------------+
//|                                                     @VaBank2.mq4 |
//|                                                     |
//|                                               leo.kindeev@tut.by |
//+------------------------------------------------------------------+

#property indicator_chart_window

//--------------------------------------------------------------------------
enum TIMEFRAME
{                       
D1,  //                      
W1   //                       
};
input TIMEFRAME  TimeFrame = W1;  
  
extern string CurPairWeek = "EURUSD,EURJPY,EURAUD,EURCAD,GBPUSD,AUDUSD,AUDJPY,NZDCHF,CADCHF,CHFJPY,AUDCHF,GBPCHF";
extern string CurPairDay  = "EURUSD,EURJPY,EURAUD,EURCAD,GBPUSD,AUDUSD,AUDJPY,NZDCHF,CADCHF,CHFJPY,AUDCHF,GBPCHF";             
extern double Depo        = 2000;
extern double StopLoss    = 100;
extern double RiskPercent = 50;
extern int    Ystart      = 15;          //    
extern int    Ystep       = 12;          //     
extern int    Xstep       = 15;          //     
extern string Font        = "Tahoma";    //  
extern int    FontSize    = 7;           //  

double size, maxsize;
string nameMaxSize;

double maxsize2;
string nameMaxSize2;

double maxsize3;
string nameMaxSize3;

int timeframe;

//--------------------------------------------------------------------------
int OnInit()
   {
   DeleteObjects();
   return(INIT_SUCCEEDED);
   }
//--------------------------------------------------------------------------
void OnDeinit(const int reason)
   {
   DeleteObjects();
   }
//--------------------------------------------------------------------------
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
   {
   if (TimeFrame==W1)
      CalcBodySize(PERIOD_W1,CurPairWeek,Ystart);
   else
      CalcBodySize(PERIOD_D1,CurPairDay,Ystart);
   return(rates_total);
   }
//--------------------------------------------------------------------------
void DeleteObjects() 
   {
   int n;
   string pairs[];
   
   int kodrazd=StringGetCharacter(",",0);
   if (TimeFrame==W1)
      n = StringSplit(CurPairWeek,kodrazd,pairs);
   else
      n = StringSplit(CurPairDay,kodrazd,pairs);

   for (int i=0; i<n; i++) ObjectDelete("size"+pairs[i]);
   ObjectDelete("sizemax1");
   ObjectDelete("sizemax2");
   ObjectDelete("sizemax3");
   ObjectDelete("lotmax1");
   ObjectDelete("lotmax2");
   ObjectDelete("lotmax3");
   ObjectDelete("period");
   }
//--------------------------------------------------------------------------

void CalcBodySize(int period, string curpair, int ybegin)
   {  
   string pairs[];
   int kodrazd=StringGetCharacter(",",0);
   int n = StringSplit(curpair,kodrazd,pairs);
   
   maxsize=0;
   maxsize2=0;
   maxsize3=0;
   
   int y=ybegin+6*Ystep;
   int x=5;
   int k=1;
   for (int i=0; i<n; i++)
      {
      CalcAndSetCurPairLabel(pairs[i], period, x, y);
      k++;
      x=x+5*Xstep;
      if (k>5)
         {
         k=1;
         x=5;
         y=y+Ystep;
         }
      }
   // ---------------------
   string DepoStopRisk="Depo="+DoubleToStr(Depo,0)+"  SL="+DoubleToStr(StopLoss,0)+
                       "  Risk="+DoubleToStr(RiskPercent,0)+"%";
   y=ybegin;
   if (period==PERIOD_W1)
      SetLabel("period", "                "+DepoStopRisk, MediumOrchid, 5, y);
   else
      SetLabel("period", "                  "+DepoStopRisk, MediumOrchid, 5, y);
   // ---------------------
   y=y+2*Ystep;
   SetMaxValueLabel("max1", nameMaxSize, maxsize, y);
   // ---------------------
   y=y+Ystep;
   SetMaxValueLabel("max2", nameMaxSize2, maxsize2, y);
   // ---------------------
   y=y+Ystep;
   SetMaxValueLabel("max3", nameMaxSize3, maxsize3, y);
   }
//--------------------------------------------------------------------------
void CalcAndSetCurPairLabel(string curname, int period, int x, int y) 
   {
   double point=0;
   int k=0;
   while (point==0)
      {
      point=MarketInfo(curname,MODE_POINT);
      double dig=MarketInfo(curname,MODE_DIGITS);
      k++;
      if (k>3) break;
      }
   
   if (point>0)
      {
      size=MathAbs(iOpen(curname,period,0)-iClose(curname,period,0))/point;
      SetLabel("size"+curname, curname+" - "+DoubleToStr(size,0), Blue, x, y);
      if (size>maxsize) 
         {
         maxsize3=maxsize2; nameMaxSize3=nameMaxSize2;
         maxsize2=maxsize; nameMaxSize2=nameMaxSize;
         maxsize=size; nameMaxSize=curname;
         }
      if (size>maxsize2 && size<maxsize) 
         {
         maxsize3=maxsize2; nameMaxSize3=nameMaxSize2;
         maxsize2=size; nameMaxSize2=curname;
         }
      if (size>maxsize3 && size<maxsize && size<maxsize2) 
         {
         maxsize3=size; nameMaxSize3=curname;
         }
      }
   }
//--------------------------------------------------------------------------
void SetMaxValueLabel(string objname, string curname, double msize, int y)
   {
   SetLabel("size"+objname, curname+" - "+DoubleToStr(msize,0), Red, 5, y);
   
   double pipValue = MarketInfo(curname,MODE_TICKVALUE);
   if (pipValue>0)
      {
      int period; if (TimeFrame==W1) period=PERIOD_W1; else period=PERIOD_D1;
      double N = 0;
      for (int i=1; i<=10; i++)
         {
         N=N+MathAbs(iOpen(curname,period,i)-iClose(curname,period,i))/MarketInfo(curname,MODE_POINT);
         }
      N=NormalizeDouble(N/10,0);
   
      double lots   = NormalizeDouble(Depo*RiskPercent/100.0/StopLoss/pipValue,2);
      SetLabel("lot"+objname, "Lot="+DoubleToStr(lots,2)+"  Spread="+MarketInfo(curname,MODE_SPREAD)+
               "  N="+DoubleToStr(N,0), MediumOrchid, 6*Xstep, y);
      }
   } 
//--------------------------------------------------------------------------
void SetLabel(string objname, string text, color colr, int x, int y) 
   {
   if (ObjectFind(objname) < 0) ObjectCreate(objname, OBJ_LABEL, 0, 0,0);
  
   ObjectSetText(objname, text, FontSize);
   ObjectSet(objname, OBJPROP_COLOR, colr);
   ObjectSet(objname, OBJPROP_XDISTANCE, x);
   ObjectSet(objname, OBJPROP_YDISTANCE, y);
   ObjectSet(objname, OBJPROP_CORNER, CORNER_LEFT_UPPER);
   ObjectSetInteger(0,objname,OBJPROP_FONTSIZE, FontSize);
   ObjectSetString( 0,objname,OBJPROP_FONT, Font);
   }
//+----------------------------------------------------------------------------+